"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var parse_commit_message_1 = require("parse-commit-message");
var ConventionalCommitsPlugin = /** @class */ (function () {
    function ConventionalCommitsPlugin() {
        this.name = 'Conventional Commits Parser';
    }
    ConventionalCommitsPlugin.prototype.apply = function (auto) {
        var _this = this;
        auto.hooks.onCreateLogParse.tap(this.name, function (logParse) {
            logParse.hooks.parseCommit.tap(_this.name, function (commit) {
                try {
                    var _a = __read(parse_commit_message_1.applyPlugins(parse_commit_message_1.mappers.increment, parse_commit_message_1.parse(commit.subject)), 1), conventionalCommit = _a[0];
                    if (conventionalCommit.header && conventionalCommit.increment) {
                        commit.labels = __spread(commit.labels, [
                            auto.semVerLabels.get(conventionalCommit.increment)
                        ]);
                    }
                }
                catch (error) {
                    auto.logger.verbose.info("No conventional commit message found for " + commit.hash);
                }
                return commit;
            });
            // should omit PR commit if there exists a commit with a CC commit message
            logParse.hooks.omitCommit.tapPromise(_this.name, function (commit) { return __awaiter(_this, void 0, void 0, function () {
                var lastRelease, allCommits, prCommits, allPrCommitHashes_1, extendedCommitsInPr;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(auto.git &&
                                auto.release &&
                                commit.pullRequest &&
                                commit.labels.length === 0)) return [3 /*break*/, 4];
                            return [4 /*yield*/, auto.git.getLatestRelease()];
                        case 1:
                            lastRelease = _a.sent();
                            return [4 /*yield*/, auto.release.getCommits(lastRelease)];
                        case 2:
                            allCommits = _a.sent();
                            return [4 /*yield*/, auto.git.getCommitsForPR(commit.pullRequest.number)];
                        case 3:
                            prCommits = _a.sent();
                            allPrCommitHashes_1 = prCommits.reduce(function (all, pr) { return __spread(all, [pr.sha]); }, []);
                            extendedCommitsInPr = allCommits.filter(function (c) {
                                return allPrCommitHashes_1.includes(c.hash);
                            });
                            return [2 /*return*/, Boolean(extendedCommitsInPr.find(function (c) { return Boolean(parse_commit_message_1.parse(c.subject)[0].header); }))];
                        case 4: return [2 /*return*/];
                    }
                });
            }); });
        });
    };
    return ConventionalCommitsPlugin;
}());
exports.default = ConventionalCommitsPlugin;
//# sourceMappingURL=index.js.map